(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@dev-stream/angular-utils', ['exports', 'rxjs'], factory) :
    (global = global || self, factory((global['dev-stream'] = global['dev-stream'] || {}, global['dev-stream']['angular-utils'] = {}), global.rxjs));
}(this, function (exports, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     * @param {?=} dataKey
     * @param {?=} routeKey
     * @param {?=} ctr
     * @return {?}
     */
    function FromRouteData(dataKey, routeKey, ctr) {
        if (dataKey === void 0) { dataKey = null; }
        if (routeKey === void 0) { routeKey = 'route'; }
        if (ctr === void 0) { ctr = null; }
        return (/**
         * @param {?} target
         * @param {?} propertyName
         * @return {?}
         */
        function (target, propertyName) {
            if (dataKey == null) {
                dataKey = propertyName;
            }
            Object.defineProperty(target, propertyName, {
                get: /**
                 * @return {?}
                 */
                function () {
                    /** @type {?} */
                    var route = (/** @type {?} */ (this[routeKey]));
                    if (route == null) {
                        console.error("Property " + routeKey + " is not \"ActivatedRoute\". Maybe you forgot to inject it");
                    }
                    /** @type {?} */
                    var data = route.snapshot.data;
                    if (data != null && dataKey in data) {
                        if (ctr != null) {
                            return new ctr(data[dataKey]);
                        }
                        else {
                            return data[dataKey];
                        }
                    }
                    else {
                        return null;
                    }
                },
                set: /**
                 * @return {?}
                 */
                function () {
                    throw new Error('Property is readonly');
                }
            });
        });
    }
    /**
     * @template T
     * @param {?=} property
     * @param {?=} routeKey
     * @param {?=} ctr
     * @return {?}
     */
    function MapRouteParams(property, routeKey, ctr) {
        if (property === void 0) { property = null; }
        if (routeKey === void 0) { routeKey = 'route'; }
        if (ctr === void 0) { ctr = null; }
        return (/**
         * @param {?} target
         * @param {?} propertyName
         * @return {?}
         */
        function (target, propertyName) {
            Object.defineProperty(target, propertyName, {
                get: /**
                 * @return {?}
                 */
                function () {
                    /** @type {?} */
                    var route = (/** @type {?} */ (this[routeKey]));
                    if (route == null) {
                        console.error("Property " + routeKey + " is not \"ActivatedRoute\". Maybe you forgot to inject it");
                    }
                    /** @type {?} */
                    var params = route.snapshot.params;
                    if (params != null) {
                        if (property == null) {
                            if (ctr == null) {
                                return params;
                            }
                            else if (ctr === 'Array') {
                                throw new Error('Field "property" should be defined to take array from params');
                            }
                            else {
                                return new ctr((/** @type {?} */ (params)));
                            }
                        }
                        if (params[property] == null) {
                            return null;
                        }
                        if (ctr == null) {
                            return params[property];
                        }
                        else if (ctr === 'Array') {
                            return JSON.parse("[" + params[property] + "]");
                        }
                        else {
                            return new ctr((/** @type {?} */ (params)));
                        }
                    }
                },
                set: /**
                 * @return {?}
                 */
                function () {
                    throw new Error('Property is readonly');
                }
            });
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var mapObjectToAttributes = (/**
     * @param {?} obj
     * @return {?}
     */
    function (obj) {
        /** @type {?} */
        var attributes = Object.keys(obj).map((/**
         * @param {?} attr
         * @return {?}
         */
        function (attr) { return attr + "=\"" + obj[attr] + "\""; }));
        return attributes.join(' ');
    });
    /** @type {?} */
    var mapObjectToStyles = (/**
     * @param {?} obj
     * @return {?}
     */
    function (obj) {
        /** @type {?} */
        var styles = Object.keys(obj).map((/**
         * @param {?} style
         * @return {?}
         */
        function (style) { return style + ": " + obj[style]; }));
        return "style=\"" + styles.join('; ') + "\"";
    });
    /** @type {?} */
    var build = (/**
     * @param {?} template
     * @param {?=} styles
     * @param {?=} attrs
     * @param {?=} classes
     * @return {?}
     */
    function (template, styles, attrs, classes) {
        if (styles === void 0) { styles = {}; }
        if (attrs === void 0) { attrs = {}; }
        if (classes === void 0) { classes = []; }
        return "<div class=\"" + classes.join(' ') + "\" " + mapObjectToStyles(styles) + " " + mapObjectToAttributes(attrs) + ">" + template + "</div>";
    });
    var Wrapper = /** @class */ (function () {
        function Wrapper(_template) {
            var _this = this;
            this._template = _template;
            this._classes = [];
            this._flexDefaults = { flex: true, alignment: 'stretch', justification: 'flex-start', direction: 'column', fix: true };
            this.withStyles = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} styles
             * @return {THIS}
             */
            function (styles) {
                _this._stylesObj = __assign({}, _this._stylesObj, styles);
                return _this;
            });
            this.withAttrs = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} attrs
             * @return {THIS}
             */
            function (attrs) {
                _this._attrsObj = __assign({}, _this._attrsObj, attrs);
                return _this;
            });
            this.withWidth = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} width
             * @return {THIS}
             */
            function (width) {
                _this._stylesObj = __assign({}, _this._stylesObj, { width: width });
                return _this;
            });
            this.withHeight = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} height
             * @return {THIS}
             */
            function (height) {
                _this._stylesObj = __assign({}, _this._stylesObj, { height: height });
                return _this;
            });
            this.withMaxWidth = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} width
             * @return {THIS}
             */
            function (width) {
                _this._stylesObj = __assign({}, _this._stylesObj, { 'max-width': width });
                return _this;
            });
            this.withMaxHeight = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} height
             * @return {THIS}
             */
            function (height) {
                _this._stylesObj = __assign({}, _this._stylesObj, { 'max-height': height });
                return _this;
            });
            this.withFlex = (/**
             * @template THIS
             * @this {THIS}
             * @param {?=} params
             * @return {THIS}
             */
            function (params) {
                if (params === void 0) { params = _this._flexDefaults; }
                _this._attrsObj = __assign({}, _this._attrsObj, _this._flexDefaults, params);
                return _this;
            });
        }
        /**
         * @template THIS
         * @this {THIS}
         * @param {?} className
         * @return {THIS}
         */
        Wrapper.prototype.withClass = /**
         * @template THIS
         * @this {THIS}
         * @param {?} className
         * @return {THIS}
         */
        function (className) {
            (/** @type {?} */ (this))._classes.push(className);
            return (/** @type {?} */ (this));
        };
        /**
         * @return {?}
         */
        Wrapper.prototype.build = /**
         * @return {?}
         */
        function () {
            return build(this._template, this._stylesObj, this._attrsObj, this._classes);
        };
        return Wrapper;
    }());
    /** @type {?} */
    var wrapper = (/**
     * @param {?} template
     * @return {?}
     */
    function (template) { return new Wrapper(template); });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var   /**
     * @abstract
     */
    FlexComponent = /** @class */ (function () {
        function FlexComponent() {
            this._classes = 'component';
            this.destroySubject = new rxjs.Subject();
            this.destroy = this.destroySubject.asObservable();
            this.flex = true;
            this.fix = true;
            this.alignment = 'stretch';
            this.justification = 'flex-start';
            this.direction = 'column';
            this.wrap = 'nowrap';
            this.additionClasses = [];
        }
        Object.defineProperty(FlexComponent.prototype, "classes", {
            get: /**
             * @return {?}
             */
            function () {
                return this._classes;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this._classes = "component " + v + " " + this.additionClasses.join(' ');
            },
            enumerable: true,
            configurable: true
        });
        // tslint:disable-next-line: use-life-cycle-interface
        // tslint:disable-next-line: use-life-cycle-interface
        /**
         * @return {?}
         */
        FlexComponent.prototype.ngOnDestroy = 
        // tslint:disable-next-line: use-life-cycle-interface
        /**
         * @return {?}
         */
        function () {
            this.destroySubject.next();
            this.destroySubject.complete();
        };
        return FlexComponent;
    }());

    exports.FlexComponent = FlexComponent;
    exports.FromRouteData = FromRouteData;
    exports.MapRouteParams = MapRouteParams;
    exports.Wrapper = Wrapper;
    exports.wrapper = wrapper;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=dev-stream-angular-utils.umd.js.map
